<?php
//this file requires certain constants to be provided in order to work, therefore it must be included by a script that defines them rather than called directly by the browser (template_37.php)
session_start();

$frame_size = getimagesize($frame);

//make sure that the window height and width set here can be accessed by the processing script as well
$_SESSION['img_window']['width'] = $window_width;
$_SESSION['img_window']['height'] = $window_height;

unset($message);
$valid_types = array('jpg'=>'image/jpeg', 'jpeg'=>'image/jpeg', 'gif'=>'image/gif', 'png'=>'image/png');
//add additional allowed filetypes by expanding this array, but remember to also add them to the switch statement in imagecropper.php if you do
if(isset($_FILES['img_file'])) {
	if($_FILES['img_file']['size'] == 0) {
		$message = "File was not received.";
	} else {
		$ext = strtolower(array_pop(explode('.', $_FILES['img_file']['name'])));
		if(isset($valid_types[$ext])) {
			$filebase = isset($_SESSION['filebase']) ? $_SESSION['filebase'] : $_SESSION['filebase'] = $upload_dir.'/'.rand(1000,9999);
			$img_name = $filebase.'_o.'.$ext;
			$_SESSION['img_upload_path'] = $_SERVER['DOCUMENT_ROOT'].$img_name;
			if(@move_uploaded_file($_FILES['img_file']['tmp_name'], $_SESSION['img_upload_path'])) {
				$_SESSION['filename'] = $filebase.'.png';
			} else {
				$message = 'Could not move uploaded file to '.$_SESSION['img_upload_path'];
				unset($_SESSION['img_upload_path']);
			}
		} else {
			$message = 'invalid extension: '.$ext.' (file type listed as: '.$_FILES['img_file']['type'].')';
		}
	}
} elseif (isset($_SESSION['filebase']) && isset($_SESSION['img_upload_path']) && file_exists($_SESSION['img_upload_path'])) {
	$img_name = str_replace($_SERVER['DOCUMENT_ROOT'], '', $_SESSION['img_upload_path']);
	$_SESSION['filename'] = $_SESSION['filebase'].'.png';
} else {
	unset($_SESSION['img_upload_path']);
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="UTF-8">
<head>
<title>image positioning tool</title>
<script src="jquery-1.2.6.pack.js"></script>
<script src="jquery-ui.packed.js"></script>
<link rel="stylesheet" href="slider.css" type="text/css" media="screen" title="Flora (Default)">
<?php if(isset($message)) : ?>
<script type="text/javascript">
alert('<?=str_replace("'","\'",$message)?>');
</script>
<?php endif; ?>
</head>
<?php
if(isset($_SESSION['img_upload_path']) && file_exists($_SESSION['img_upload_path'])) {

	$window_aspect = $window_width / $window_height;
	$dimensions = getimagesize($_SESSION['img_upload_path']);
	$left = ($dimensions[0]-$window_width)/2;
	$top = ($dimensions[1]-$window_height)/2;
}
?>
<body style="background-color:#444">
<div align="center">
<table style="height:500px; border:0px red double; background-color:#444; position:absolute; left:0; top:0" height="100px" cellpadding="0" cellspacing="0">
<tr>
<td colspan="2" style="background-color:white;">
<div style="overflow:hidden; width:<?=$window_width?>px; height:<?=$window_height?>px; position:absolute; left:<?=$window_left?>px; top:<?=$window_top?>px; border:black inset 1px;">
<?php if(isset($_SESSION['img_upload_path']) && file_exists($_SESSION['img_upload_path'])) : ?>
<img src="<?=$img_name.'?'.rand(100000000,999999999)?>" style="position:absolute; left:-<?=$left?>px; top:-<?=$top?>px" width="<?=$dimensions[0];?>px" height="<?=$dimensions[1];?>px" id="preview"/>
<?php else : ?>
<h3 align="center">Upload an image to begin</h3>
<?php endif; ?>
</div>
<div style="background-image:url(<?=$frame?>); width:<?=$frame_size[0]?>px; height:<?=$frame_size[1]?>px; position:absolute; left:0; top:0">
</div>
<div style=" width:<?=$frame_size[0]?>px; height:<?=$frame_size[1]?>px;"></div>
</td>
</tr>
<tr><td>
<div id='slider_scale' class='ui-slider-1' style="margin:10px;"></div>
</td><td>
<button id="build" type="button">Save Cropped Image</button></td>
</tr>
<tr>
<td colspan="2" align="center">
<?php
if(isset($_SESSION['img_upload_path']) && file_exists($_SESSION['img_upload_path'])) {
	$img_aspect = $dimensions[0] / $dimensions[1];
	if($img_aspect > $window_aspect) {
		$easel_width = $mult*$window_width;
		$easel_height = $easel_width / $img_aspect;
		$scale = $dimensions[0] / $easel_width;
		$scale_min = $window_height / $easel_height;
	} else {
		$easel_height = $mult*$window_height;
		$easel_width = $easel_height * $img_aspect;
		$scale = $dimensions[1] / $easel_height;
		$scale_min = $window_width / $easel_width;
	}
	//use $scale to calculate the starting points for the dragger
	$dragger_width = $window_width / $scale;
	$dragger_height = $window_height / $scale;
	$dragger_top = ($top/$scale)+$dragger_height;
	$dragger_left = 4+$left*$scale;
	//make sure that '$scale' does not lie outside the range set by scale_min and scale_max
	$scale_max = max($scale_max, $scale);
}
?>
<div style="width:<?=$mult*$window_width?>px; height:<?=$mult*$window_height?>px; border:3px black inset; background-color:#CCCCCC" align="center">
<?php if(isset($_SESSION['img_upload_path']) && file_exists($_SESSION['img_upload_path'])) : ?>
<img src="<?=$img_name.'?'.rand(100000000,999999999)?>" width="<?=$easel_width?>px" height="<?=$easel_height?>" <?php if($easel_height < $mult*$window_height) { echo 'style="margin-top:'.(($mult*$window_height - $easel_height)/2).'px"'; } ?>  id="easel">
<div style="width:<?=$dragger_width?>px; height:<?=$dragger_height?>px; border:0px black dashed; background-image:url(grid.gif); background-position:center; position:relative; top:-<?=$dragger_top?>px; left:0; cursor:pointer" id="dragger"></div>
</img>
<?php endif; ?>
</div>
</td>
</tr>
<tr>
<td colspan="2" align="center">
<input type="hidden" id="left_pos" />
<input type="hidden" id="top_pos" />
<input type="hidden" id="width" />
<input type="hidden" id="height" />
<input type="hidden" id="left" value="<?=$left?>" name="left" />
<input type="hidden" id="top" value="<?=$top?>" name="top" />
<input type="hidden" id="scale" value="1" name="scale" />
<div style="padding:4px">
<form action="" method="POST" enctype="multipart/form-data">
<strong style="color:white">Upload an image: </strong>
<input type="file" name="img_file" />
<input type="submit" value="Upload" /><br />
</form>
</div>
</td>
</tr>
</table>
<?php if(isset($_SESSION['img_upload_path']) && file_exists($_SESSION['img_upload_path'])) : ?>


</div>
</body>
<script>
var scale = <?=	($scale_min < $scale) ? $scale : $scale_min / $scale ?>;
var dragger_width = <?=$dragger_width?>;
var dragger_height = <?=$dragger_height?>;
var window_width = <?=$window_width?>;
var window_height = <?=$window_height?>;
var img_width = <?=$dimensions[0]?>;
var img_height = <?=$dimensions[1]?>;
var easel_width = <?=$easel_width?>;
var easel_height = <?=$easel_height?>;
var drag = function(event, data) {
	var left = (-<?=$easel_width/2?>-data.position.left+(dragger_width/2))*scale;
	if(left > 0.5) { left = 0; }
	var top = (-<?=$easel_height?>-data.position.top-4)*scale;
	$('#preview').css({left:left, top:top});
	$('#left').val(-left);
	$('#top').val(-top);
	$('#left_pos').val(data.position.left);
	$('#top_pos').val(data.position.top);
}

var slide = function(event, data) {
	scale = data.value / 1000;
	dragger_width = window_width / scale;
	$('#width').val(dragger_width);
	dragger_height = window_height / scale;
	$('#height').val(dragger_height);
	var old_width = parseInt($('#dragger').css('width'));
	var old_height = parseInt($('#dragger').css('height'));
	var old_left = parseInt($('#dragger').css('left'));
	var old_top = parseInt($('#dragger').css('top'));
	$('#dragger').css({width:dragger_width+'px', height:dragger_height+'px'})
	if(dragger_height+old_top > -4) {
		$('#dragger').css({top:'-'+(dragger_height+4)+'px'});
	} else if (old_top-(dragger_height-old_height)/2 < -(<?=$easel_height?>+4)) {
		$('#dragger').css('top','-'+(<?=$easel_height?>+4)+'px');
	} else {
		$('#dragger').css({top:(old_top-(dragger_height-old_height)/2)+'px'});
	}
	$('#top_pos').val(parseInt($('#dragger').css('top')));
	if(2*old_left+dragger_width > easel_width) {
		$('#dragger').css({left:(easel_width-dragger_width)/2+'px'});
	} else if(-1*(old_left-dragger_width/2) > easel_width/2) {
		$('#dragger').css('left',(dragger_width-easel_width)/2+'px');
	} else {
		$('#dragger').css({left:old_left+'px'});
	}
	$('#left_pos').val(parseInt($('#dragger').css('left')));
	var left = (-<?=$easel_width/2?>-parseInt($('#dragger').css('left'))+dragger_width/2)*scale;
	var top = (-<?=$easel_height?>-parseInt($('#dragger').css('top'))-4)*scale;
	img_width = Math.round(easel_width*scale);
	img_height = Math.round(easel_height*scale);
	$('#preview').css({left:left, top:top});
	document.getElementById('preview').width = img_width;
	document.getElementById('preview').height = img_height;
	$('#left').val(-left);
	$('#top').val(-top);
	$('#scale').val(scale/<?=$scale?>);

}
var fadeIn = function() {
	$(this).fadeIn('slow');
}
$('document').ready(function() {
	$('#dragger').draggable({containment:'#easel', drag:drag});
	$('#slider_scale').slider({startValue:(Math.round(1000*scale)), min:(Math.round(1000*<?=$scale_min?>)), max:(1000*<?=$scale_max?>), slide:slide});
	$('#build').click(function(event) {
		var final_cut = window.parent.document.getElementById('final_cut');
		$(final_cut).load('imagecropper.php', {left:$('#left').val(), top:$('#top').val(), scale:$('#scale').val()}, fadeIn).hide();
	});
});
</script>
<?php else: ?>
<script type="text/javascript">
$('#slider_scale').slider();
</script>
<?php endif; ?>
</html>